<?php

namespace Pepitelabs\PWS;

/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'GetDocumentsRequestContainer' => '\\Pepitelabs\\PWS\\ShippingDocumentsService\\GetDocumentsRequestContainer',
            'RequestContainer' => '\\Pepitelabs\\PWS\\ShippingDocumentsService\\RequestContainer',
            'ArrayOfDocumentCriteria' => '\\Pepitelabs\\PWS\\ShippingDocumentsService\\ArrayOfDocumentCriteria',
            'DocumentCriteria' => '\\Pepitelabs\\PWS\\ShippingDocumentsService\\DocumentCriteria',
            'PIN' => '\\Pepitelabs\\PWS\\ShippingDocumentsService\\PIN',
            'DocumentTypes' => '\\Pepitelabs\\PWS\\ShippingDocumentsService\\DocumentTypes',
            'RequestContext' => '\\Pepitelabs\\PWS\\ShippingDocumentsService\\RequestContext',
            'GetDocumentsResponseContainer' => '\\Pepitelabs\\PWS\\ShippingDocumentsService\\GetDocumentsResponseContainer',
            'ResponseContainer' => '\\Pepitelabs\\PWS\\ShippingDocumentsService\\ResponseContainer',
            'ResponseInformation' => '\\Pepitelabs\\PWS\\ShippingDocumentsService\\ResponseInformation',
            'ArrayOfError' => '\\Pepitelabs\\PWS\\ShippingDocumentsService\\ArrayOfError',
            'Error' => '\\Pepitelabs\\PWS\\ShippingDocumentsService\\Error',
            'ArrayOfInformationalMessage' => '\\Pepitelabs\\PWS\\ShippingDocumentsService\\ArrayOfInformationalMessage',
            'InformationalMessage' => '\\Pepitelabs\\PWS\\ShippingDocumentsService\\InformationalMessage',
            'ArrayOfDocument' => '\\Pepitelabs\\PWS\\ShippingDocumentsService\\ArrayOfDocument',
            'Document' => '\\Pepitelabs\\PWS\\ShippingDocumentsService\\Document',
            'ArrayOfDocumentDetail' => '\\Pepitelabs\\PWS\\ShippingDocumentsService\\ArrayOfDocumentDetail',
            'DocumentDetail' => '\\Pepitelabs\\PWS\\ShippingDocumentsService\\DocumentDetail',
            'ResponseContext' => '\\Pepitelabs\\PWS\\ShippingDocumentsService\\ResponseContext',
            'GetShipmentManifestDocumentRequestContainer' => '\\Pepitelabs\\PWS\\ShippingDocumentsService\\GetShipmentManifestDocumentRequestContainer',
            'ArrayOfShipmentManifestDocumentCriteria' => '\\Pepitelabs\\PWS\\ShippingDocumentsService\\ArrayOfShipmentManifestDocumentCriteria',
            'ShipmentManifestDocumentCriteria' => '\\Pepitelabs\\PWS\\ShippingDocumentsService\\ShipmentManifestDocumentCriteria',
            'GetShipmentManifestDocumentResponseContainer' => '\\Pepitelabs\\PWS\\ShippingDocumentsService\\GetShipmentManifestDocumentResponseContainer',
            'ArrayOfManifestBatch' => '\\Pepitelabs\\PWS\\ShippingDocumentsService\\ArrayOfManifestBatch',
            'ManifestBatch' => '\\Pepitelabs\\PWS\\ShippingDocumentsService\\ManifestBatch',
            'ArrayOfManifestBatchDetail' => '\\Pepitelabs\\PWS\\ShippingDocumentsService\\ArrayOfManifestBatchDetail',
            'ManifestBatchDetail' => '\\Pepitelabs\\PWS\\ShippingDocumentsService\\ManifestBatchDetail',
            'ValidationFault' => '\\Pepitelabs\\PWS\\ShippingDocumentsService\\ValidationFault',
            'ArrayOfValidationDetail' => '\\Pepitelabs\\PWS\\ShippingDocumentsService\\ArrayOfValidationDetail',
            'ValidationDetail' => '\\Pepitelabs\\PWS\\ShippingDocumentsService\\ValidationDetail',
        );
    }
}
