<?php

namespace Pepitelabs\PWS\ShippingDocumentsService;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfDocumentCriteria ShippingDocumentsService
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfDocumentCriteria
 * @subpackage Arrays
 */
class ArrayOfDocumentCriteria extends AbstractStructArrayBase
{
    /**
     * The DocumentCriteria
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \Pepitelabs\PWS\ShippingDocumentsService\DocumentCriteria[]
     */
    public $DocumentCriteria;
    /**
     * Constructor method for ArrayOfDocumentCriteria
     * @uses ArrayOfDocumentCriteria::setDocumentCriteria()
     * @param \Pepitelabs\PWS\ShippingDocumentsService\DocumentCriteria[] $documentCriteria
     */
    public function __construct(array $documentCriteria = array())
    {
        $this
            ->setDocumentCriteria($documentCriteria);
    }
    /**
     * Get DocumentCriteria value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \Pepitelabs\PWS\ShippingDocumentsService\DocumentCriteria[]|null
     */
    public function getDocumentCriteria()
    {
        return isset($this->DocumentCriteria) ? $this->DocumentCriteria : null;
    }
    /**
     * This method is responsible for validating the values passed to the setDocumentCriteria method
     * This method is willingly generated in order to preserve the one-line inline validation within the setDocumentCriteria method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateDocumentCriteriaForArrayConstraintsFromSetDocumentCriteria(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfDocumentCriteriaDocumentCriteriaItem) {
            // validation for constraint: itemType
            if (!$arrayOfDocumentCriteriaDocumentCriteriaItem instanceof \Pepitelabs\PWS\ShippingDocumentsService\DocumentCriteria) {
                $invalidValues[] = is_object($arrayOfDocumentCriteriaDocumentCriteriaItem) ? get_class($arrayOfDocumentCriteriaDocumentCriteriaItem) : sprintf('%s(%s)', gettype($arrayOfDocumentCriteriaDocumentCriteriaItem), var_export($arrayOfDocumentCriteriaDocumentCriteriaItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The DocumentCriteria property can only contain items of type \Pepitelabs\PWS\ShippingDocumentsService\DocumentCriteria, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set DocumentCriteria value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \Pepitelabs\PWS\ShippingDocumentsService\DocumentCriteria[] $documentCriteria
     * @return \Pepitelabs\PWS\ShippingDocumentsService\ArrayOfDocumentCriteria
     */
    public function setDocumentCriteria(array $documentCriteria = array())
    {
        // validation for constraint: array
        if ('' !== ($documentCriteriaArrayErrorMessage = self::validateDocumentCriteriaForArrayConstraintsFromSetDocumentCriteria($documentCriteria))) {
            throw new \InvalidArgumentException($documentCriteriaArrayErrorMessage, __LINE__);
        }
        if (is_null($documentCriteria) || (is_array($documentCriteria) && empty($documentCriteria))) {
            unset($this->DocumentCriteria);
        } else {
            $this->DocumentCriteria = $documentCriteria;
        }
        return $this;
    }
    /**
     * Add item to DocumentCriteria value
     * @throws \InvalidArgumentException
     * @param \Pepitelabs\PWS\ShippingDocumentsService\DocumentCriteria $item
     * @return \Pepitelabs\PWS\ShippingDocumentsService\ArrayOfDocumentCriteria
     */
    public function addToDocumentCriteria(\Pepitelabs\PWS\ShippingDocumentsService\DocumentCriteria $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \Pepitelabs\PWS\ShippingDocumentsService\DocumentCriteria) {
            throw new \InvalidArgumentException(sprintf('The DocumentCriteria property can only contain items of type \Pepitelabs\PWS\ShippingDocumentsService\DocumentCriteria, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->DocumentCriteria[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \Pepitelabs\PWS\ShippingDocumentsService\DocumentCriteria|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \Pepitelabs\PWS\ShippingDocumentsService\DocumentCriteria|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \Pepitelabs\PWS\ShippingDocumentsService\DocumentCriteria|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \Pepitelabs\PWS\ShippingDocumentsService\DocumentCriteria|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \Pepitelabs\PWS\ShippingDocumentsService\DocumentCriteria|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string DocumentCriteria
     */
    public function getAttributeName()
    {
        return 'DocumentCriteria';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \Pepitelabs\PWS\ShippingDocumentsService\ArrayOfDocumentCriteria
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
