<?php

namespace Pepitelabs\PWS\ShippingDocumentsService;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfDocumentDetail ShippingDocumentsService
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfDocumentDetail
 * @subpackage Arrays
 */
class ArrayOfDocumentDetail extends AbstractStructArrayBase
{
    /**
     * The DocumentDetail
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \Pepitelabs\PWS\ShippingDocumentsService\DocumentDetail[]
     */
    public $DocumentDetail;
    /**
     * Constructor method for ArrayOfDocumentDetail
     * @uses ArrayOfDocumentDetail::setDocumentDetail()
     * @param \Pepitelabs\PWS\ShippingDocumentsService\DocumentDetail[] $documentDetail
     */
    public function __construct(array $documentDetail = array())
    {
        $this
            ->setDocumentDetail($documentDetail);
    }
    /**
     * Get DocumentDetail value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \Pepitelabs\PWS\ShippingDocumentsService\DocumentDetail[]|null
     */
    public function getDocumentDetail()
    {
        return isset($this->DocumentDetail) ? $this->DocumentDetail : null;
    }
    /**
     * This method is responsible for validating the values passed to the setDocumentDetail method
     * This method is willingly generated in order to preserve the one-line inline validation within the setDocumentDetail method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateDocumentDetailForArrayConstraintsFromSetDocumentDetail(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfDocumentDetailDocumentDetailItem) {
            // validation for constraint: itemType
            if (!$arrayOfDocumentDetailDocumentDetailItem instanceof \Pepitelabs\PWS\ShippingDocumentsService\DocumentDetail) {
                $invalidValues[] = is_object($arrayOfDocumentDetailDocumentDetailItem) ? get_class($arrayOfDocumentDetailDocumentDetailItem) : sprintf('%s(%s)', gettype($arrayOfDocumentDetailDocumentDetailItem), var_export($arrayOfDocumentDetailDocumentDetailItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The DocumentDetail property can only contain items of type \Pepitelabs\PWS\ShippingDocumentsService\DocumentDetail, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set DocumentDetail value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \Pepitelabs\PWS\ShippingDocumentsService\DocumentDetail[] $documentDetail
     * @return \Pepitelabs\PWS\ShippingDocumentsService\ArrayOfDocumentDetail
     */
    public function setDocumentDetail(array $documentDetail = array())
    {
        // validation for constraint: array
        if ('' !== ($documentDetailArrayErrorMessage = self::validateDocumentDetailForArrayConstraintsFromSetDocumentDetail($documentDetail))) {
            throw new \InvalidArgumentException($documentDetailArrayErrorMessage, __LINE__);
        }
        if (is_null($documentDetail) || (is_array($documentDetail) && empty($documentDetail))) {
            unset($this->DocumentDetail);
        } else {
            $this->DocumentDetail = $documentDetail;
        }
        return $this;
    }
    /**
     * Add item to DocumentDetail value
     * @throws \InvalidArgumentException
     * @param \Pepitelabs\PWS\ShippingDocumentsService\DocumentDetail $item
     * @return \Pepitelabs\PWS\ShippingDocumentsService\ArrayOfDocumentDetail
     */
    public function addToDocumentDetail(\Pepitelabs\PWS\ShippingDocumentsService\DocumentDetail $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \Pepitelabs\PWS\ShippingDocumentsService\DocumentDetail) {
            throw new \InvalidArgumentException(sprintf('The DocumentDetail property can only contain items of type \Pepitelabs\PWS\ShippingDocumentsService\DocumentDetail, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->DocumentDetail[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \Pepitelabs\PWS\ShippingDocumentsService\DocumentDetail|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \Pepitelabs\PWS\ShippingDocumentsService\DocumentDetail|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \Pepitelabs\PWS\ShippingDocumentsService\DocumentDetail|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \Pepitelabs\PWS\ShippingDocumentsService\DocumentDetail|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \Pepitelabs\PWS\ShippingDocumentsService\DocumentDetail|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string DocumentDetail
     */
    public function getAttributeName()
    {
        return 'DocumentDetail';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \Pepitelabs\PWS\ShippingDocumentsService\ArrayOfDocumentDetail
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
