<?php

namespace Pepitelabs\PWS\ShippingDocumentsService;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfManifestBatch ShippingDocumentsService
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfManifestBatch
 * @subpackage Arrays
 */
class ArrayOfManifestBatch extends AbstractStructArrayBase
{
    /**
     * The ManifestBatch
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \Pepitelabs\PWS\ShippingDocumentsService\ManifestBatch[]
     */
    public $ManifestBatch;
    /**
     * Constructor method for ArrayOfManifestBatch
     * @uses ArrayOfManifestBatch::setManifestBatch()
     * @param \Pepitelabs\PWS\ShippingDocumentsService\ManifestBatch[] $manifestBatch
     */
    public function __construct(array $manifestBatch = array())
    {
        $this
            ->setManifestBatch($manifestBatch);
    }
    /**
     * Get ManifestBatch value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \Pepitelabs\PWS\ShippingDocumentsService\ManifestBatch[]|null
     */
    public function getManifestBatch()
    {
        return isset($this->ManifestBatch) ? $this->ManifestBatch : null;
    }
    /**
     * This method is responsible for validating the values passed to the setManifestBatch method
     * This method is willingly generated in order to preserve the one-line inline validation within the setManifestBatch method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateManifestBatchForArrayConstraintsFromSetManifestBatch(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfManifestBatchManifestBatchItem) {
            // validation for constraint: itemType
            if (!$arrayOfManifestBatchManifestBatchItem instanceof \Pepitelabs\PWS\ShippingDocumentsService\ManifestBatch) {
                $invalidValues[] = is_object($arrayOfManifestBatchManifestBatchItem) ? get_class($arrayOfManifestBatchManifestBatchItem) : sprintf('%s(%s)', gettype($arrayOfManifestBatchManifestBatchItem), var_export($arrayOfManifestBatchManifestBatchItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ManifestBatch property can only contain items of type \Pepitelabs\PWS\ShippingDocumentsService\ManifestBatch, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ManifestBatch value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \Pepitelabs\PWS\ShippingDocumentsService\ManifestBatch[] $manifestBatch
     * @return \Pepitelabs\PWS\ShippingDocumentsService\ArrayOfManifestBatch
     */
    public function setManifestBatch(array $manifestBatch = array())
    {
        // validation for constraint: array
        if ('' !== ($manifestBatchArrayErrorMessage = self::validateManifestBatchForArrayConstraintsFromSetManifestBatch($manifestBatch))) {
            throw new \InvalidArgumentException($manifestBatchArrayErrorMessage, __LINE__);
        }
        if (is_null($manifestBatch) || (is_array($manifestBatch) && empty($manifestBatch))) {
            unset($this->ManifestBatch);
        } else {
            $this->ManifestBatch = $manifestBatch;
        }
        return $this;
    }
    /**
     * Add item to ManifestBatch value
     * @throws \InvalidArgumentException
     * @param \Pepitelabs\PWS\ShippingDocumentsService\ManifestBatch $item
     * @return \Pepitelabs\PWS\ShippingDocumentsService\ArrayOfManifestBatch
     */
    public function addToManifestBatch(\Pepitelabs\PWS\ShippingDocumentsService\ManifestBatch $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \Pepitelabs\PWS\ShippingDocumentsService\ManifestBatch) {
            throw new \InvalidArgumentException(sprintf('The ManifestBatch property can only contain items of type \Pepitelabs\PWS\ShippingDocumentsService\ManifestBatch, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ManifestBatch[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \Pepitelabs\PWS\ShippingDocumentsService\ManifestBatch|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \Pepitelabs\PWS\ShippingDocumentsService\ManifestBatch|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \Pepitelabs\PWS\ShippingDocumentsService\ManifestBatch|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \Pepitelabs\PWS\ShippingDocumentsService\ManifestBatch|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \Pepitelabs\PWS\ShippingDocumentsService\ManifestBatch|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ManifestBatch
     */
    public function getAttributeName()
    {
        return 'ManifestBatch';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \Pepitelabs\PWS\ShippingDocumentsService\ArrayOfManifestBatch
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
