<?php

namespace Pepitelabs\PWS\ShippingDocumentsService;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfManifestBatchDetail ShippingDocumentsService
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfManifestBatchDetail
 * @subpackage Arrays
 */
class ArrayOfManifestBatchDetail extends AbstractStructArrayBase
{
    /**
     * The ManifestBatchDetail
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \Pepitelabs\PWS\ShippingDocumentsService\ManifestBatchDetail[]
     */
    public $ManifestBatchDetail;
    /**
     * Constructor method for ArrayOfManifestBatchDetail
     * @uses ArrayOfManifestBatchDetail::setManifestBatchDetail()
     * @param \Pepitelabs\PWS\ShippingDocumentsService\ManifestBatchDetail[] $manifestBatchDetail
     */
    public function __construct(array $manifestBatchDetail = array())
    {
        $this
            ->setManifestBatchDetail($manifestBatchDetail);
    }
    /**
     * Get ManifestBatchDetail value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \Pepitelabs\PWS\ShippingDocumentsService\ManifestBatchDetail[]|null
     */
    public function getManifestBatchDetail()
    {
        return isset($this->ManifestBatchDetail) ? $this->ManifestBatchDetail : null;
    }
    /**
     * This method is responsible for validating the values passed to the setManifestBatchDetail method
     * This method is willingly generated in order to preserve the one-line inline validation within the setManifestBatchDetail method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateManifestBatchDetailForArrayConstraintsFromSetManifestBatchDetail(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfManifestBatchDetailManifestBatchDetailItem) {
            // validation for constraint: itemType
            if (!$arrayOfManifestBatchDetailManifestBatchDetailItem instanceof \Pepitelabs\PWS\ShippingDocumentsService\ManifestBatchDetail) {
                $invalidValues[] = is_object($arrayOfManifestBatchDetailManifestBatchDetailItem) ? get_class($arrayOfManifestBatchDetailManifestBatchDetailItem) : sprintf('%s(%s)', gettype($arrayOfManifestBatchDetailManifestBatchDetailItem), var_export($arrayOfManifestBatchDetailManifestBatchDetailItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ManifestBatchDetail property can only contain items of type \Pepitelabs\PWS\ShippingDocumentsService\ManifestBatchDetail, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ManifestBatchDetail value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \Pepitelabs\PWS\ShippingDocumentsService\ManifestBatchDetail[] $manifestBatchDetail
     * @return \Pepitelabs\PWS\ShippingDocumentsService\ArrayOfManifestBatchDetail
     */
    public function setManifestBatchDetail(array $manifestBatchDetail = array())
    {
        // validation for constraint: array
        if ('' !== ($manifestBatchDetailArrayErrorMessage = self::validateManifestBatchDetailForArrayConstraintsFromSetManifestBatchDetail($manifestBatchDetail))) {
            throw new \InvalidArgumentException($manifestBatchDetailArrayErrorMessage, __LINE__);
        }
        if (is_null($manifestBatchDetail) || (is_array($manifestBatchDetail) && empty($manifestBatchDetail))) {
            unset($this->ManifestBatchDetail);
        } else {
            $this->ManifestBatchDetail = $manifestBatchDetail;
        }
        return $this;
    }
    /**
     * Add item to ManifestBatchDetail value
     * @throws \InvalidArgumentException
     * @param \Pepitelabs\PWS\ShippingDocumentsService\ManifestBatchDetail $item
     * @return \Pepitelabs\PWS\ShippingDocumentsService\ArrayOfManifestBatchDetail
     */
    public function addToManifestBatchDetail(\Pepitelabs\PWS\ShippingDocumentsService\ManifestBatchDetail $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \Pepitelabs\PWS\ShippingDocumentsService\ManifestBatchDetail) {
            throw new \InvalidArgumentException(sprintf('The ManifestBatchDetail property can only contain items of type \Pepitelabs\PWS\ShippingDocumentsService\ManifestBatchDetail, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ManifestBatchDetail[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \Pepitelabs\PWS\ShippingDocumentsService\ManifestBatchDetail|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \Pepitelabs\PWS\ShippingDocumentsService\ManifestBatchDetail|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \Pepitelabs\PWS\ShippingDocumentsService\ManifestBatchDetail|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \Pepitelabs\PWS\ShippingDocumentsService\ManifestBatchDetail|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \Pepitelabs\PWS\ShippingDocumentsService\ManifestBatchDetail|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ManifestBatchDetail
     */
    public function getAttributeName()
    {
        return 'ManifestBatchDetail';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \Pepitelabs\PWS\ShippingDocumentsService\ArrayOfManifestBatchDetail
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
