<?php

namespace Pepitelabs\PWS\ShippingDocumentsService;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Document ShippingDocumentsService
 * Meta information extracted from the WSDL
 * - documentation: Document
 * - nillable: true
 * - type: tns:Document
 * @subpackage Structs
 */
class Document extends AbstractStructBase
{
    /**
     * The PIN
     * Meta information extracted from the WSDL
     * - documentation: PIN - PIN
     * - nillable: true
     * @var \Pepitelabs\PWS\ShippingDocumentsService\PIN
     */
    public $PIN;
    /**
     * The DocumentDetails
     * Meta information extracted from the WSDL
     * - documentation: DocumentDetails - DocumentDetail[]
     * - nillable: true
     * @var \Pepitelabs\PWS\ShippingDocumentsService\ArrayOfDocumentDetail
     */
    public $DocumentDetails;
    /**
     * Constructor method for Document
     * @uses Document::setPIN()
     * @uses Document::setDocumentDetails()
     * @param \Pepitelabs\PWS\ShippingDocumentsService\PIN $pIN
     * @param \Pepitelabs\PWS\ShippingDocumentsService\ArrayOfDocumentDetail $documentDetails
     */
    public function __construct(\Pepitelabs\PWS\ShippingDocumentsService\PIN $pIN = null, \Pepitelabs\PWS\ShippingDocumentsService\ArrayOfDocumentDetail $documentDetails = null)
    {
        $this
            ->setPIN($pIN)
            ->setDocumentDetails($documentDetails);
    }
    /**
     * Get PIN value
     * @return \Pepitelabs\PWS\ShippingDocumentsService\PIN|null
     */
    public function getPIN()
    {
        return $this->PIN;
    }
    /**
     * Set PIN value
     * @param \Pepitelabs\PWS\ShippingDocumentsService\PIN $pIN
     * @return \Pepitelabs\PWS\ShippingDocumentsService\Document
     */
    public function setPIN(\Pepitelabs\PWS\ShippingDocumentsService\PIN $pIN = null)
    {
        $this->PIN = $pIN;
        return $this;
    }
    /**
     * Get DocumentDetails value
     * @return \Pepitelabs\PWS\ShippingDocumentsService\ArrayOfDocumentDetail|null
     */
    public function getDocumentDetails()
    {
        return $this->DocumentDetails;
    }
    /**
     * Set DocumentDetails value
     * @param \Pepitelabs\PWS\ShippingDocumentsService\ArrayOfDocumentDetail $documentDetails
     * @return \Pepitelabs\PWS\ShippingDocumentsService\Document
     */
    public function setDocumentDetails(\Pepitelabs\PWS\ShippingDocumentsService\ArrayOfDocumentDetail $documentDetails = null)
    {
        $this->DocumentDetails = $documentDetails;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \Pepitelabs\PWS\ShippingDocumentsService\Document
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
