<?php

namespace Pepitelabs\PWS\ShippingDocumentsService;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GetDocumentsResponseContainer ShippingDocumentsService
 * Meta information extracted from the WSDL
 * - documentation: GetDocumentsResponse
 * - nillable: true
 * - type: tns:GetDocumentsResponseContainer
 * @subpackage Structs
 */
class GetDocumentsResponseContainer extends ResponseContainer
{
    /**
     * The Documents
     * Meta information extracted from the WSDL
     * - documentation: Documents - Document[]
     * - minOccurs: 0
     * - nillable: true
     * @var \Pepitelabs\PWS\ShippingDocumentsService\ArrayOfDocument
     */
    public $Documents;
    /**
     * Constructor method for GetDocumentsResponseContainer
     * @uses GetDocumentsResponseContainer::setDocuments()
     * @param \Pepitelabs\PWS\ShippingDocumentsService\ArrayOfDocument $documents
     */
    public function __construct(\Pepitelabs\PWS\ShippingDocumentsService\ArrayOfDocument $documents = null)
    {
        $this
            ->setDocuments($documents);
    }
    /**
     * Get Documents value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \Pepitelabs\PWS\ShippingDocumentsService\ArrayOfDocument|null
     */
    public function getDocuments()
    {
        return isset($this->Documents) ? $this->Documents : null;
    }
    /**
     * Set Documents value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \Pepitelabs\PWS\ShippingDocumentsService\ArrayOfDocument $documents
     * @return \Pepitelabs\PWS\ShippingDocumentsService\GetDocumentsResponseContainer
     */
    public function setDocuments(\Pepitelabs\PWS\ShippingDocumentsService\ArrayOfDocument $documents = null)
    {
        if (is_null($documents) || (is_array($documents) && empty($documents))) {
            unset($this->Documents);
        } else {
            $this->Documents = $documents;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \Pepitelabs\PWS\ShippingDocumentsService\GetDocumentsResponseContainer
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
