<?php

namespace Pepitelabs\PWS\ShippingDocumentsService;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GetShipmentManifestDocumentResponseContainer
 * ShippingDocumentsService
 * Meta information extracted from the WSDL
 * - documentation: GetShipmentManifestDocumentResponse
 * - nillable: true
 * - type: tns:GetShipmentManifestDocumentResponseContainer
 * @subpackage Structs
 */
class GetShipmentManifestDocumentResponseContainer extends ResponseContainer
{
    /**
     * The ManifestBatches
     * Meta information extracted from the WSDL
     * - documentation: ManifestBatches - ManifestBatch[]
     * - minOccurs: 0
     * - nillable: true
     * @var \Pepitelabs\PWS\ShippingDocumentsService\ArrayOfManifestBatch
     */
    public $ManifestBatches;
    /**
     * Constructor method for GetShipmentManifestDocumentResponseContainer
     * @uses GetShipmentManifestDocumentResponseContainer::setManifestBatches()
     * @param \Pepitelabs\PWS\ShippingDocumentsService\ArrayOfManifestBatch $manifestBatches
     */
    public function __construct(\Pepitelabs\PWS\ShippingDocumentsService\ArrayOfManifestBatch $manifestBatches = null)
    {
        $this
            ->setManifestBatches($manifestBatches);
    }
    /**
     * Get ManifestBatches value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \Pepitelabs\PWS\ShippingDocumentsService\ArrayOfManifestBatch|null
     */
    public function getManifestBatches()
    {
        return isset($this->ManifestBatches) ? $this->ManifestBatches : null;
    }
    /**
     * Set ManifestBatches value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \Pepitelabs\PWS\ShippingDocumentsService\ArrayOfManifestBatch $manifestBatches
     * @return \Pepitelabs\PWS\ShippingDocumentsService\GetShipmentManifestDocumentResponseContainer
     */
    public function setManifestBatches(\Pepitelabs\PWS\ShippingDocumentsService\ArrayOfManifestBatch $manifestBatches = null)
    {
        if (is_null($manifestBatches) || (is_array($manifestBatches) && empty($manifestBatches))) {
            unset($this->ManifestBatches);
        } else {
            $this->ManifestBatches = $manifestBatches;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \Pepitelabs\PWS\ShippingDocumentsService\GetShipmentManifestDocumentResponseContainer
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
