<?php

namespace Pepitelabs\PWS\ShippingDocumentsService;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ShipmentManifestDocumentCriteria ShippingDocumentsService
 * Meta information extracted from the WSDL
 * - documentation: ShipmentManifestDocumentCriteria
 * - nillable: true
 * - type: tns:ShipmentManifestDocumentCriteria
 * @subpackage Structs
 */
class ShipmentManifestDocumentCriteria extends AbstractStructBase
{
    /**
     * The ManifestDate
     * Meta information extracted from the WSDL
     * - documentation: ShipmentManifestDate - string
     * - nillable: true
     * @var string
     */
    public $ManifestDate;
    /**
     * Constructor method for ShipmentManifestDocumentCriteria
     * @uses ShipmentManifestDocumentCriteria::setManifestDate()
     * @param string $manifestDate
     */
    public function __construct($manifestDate = null)
    {
        $this
            ->setManifestDate($manifestDate);
    }
    /**
     * Get ManifestDate value
     * @return string|null
     */
    public function getManifestDate()
    {
        return $this->ManifestDate;
    }
    /**
     * Set ManifestDate value
     * @param string $manifestDate
     * @return \Pepitelabs\PWS\ShippingDocumentsService\ShipmentManifestDocumentCriteria
     */
    public function setManifestDate($manifestDate = null)
    {
        // validation for constraint: string
        if (!is_null($manifestDate) && !is_string($manifestDate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($manifestDate, true), gettype($manifestDate)), __LINE__);
        }
        $this->ManifestDate = $manifestDate;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \Pepitelabs\PWS\ShippingDocumentsService\ShipmentManifestDocumentCriteria
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
